
import java.util.*;
import java.io.*;

public class prefix_font
{
   public static void main(String[] args) throws Exception
   {
      PrintWriter out = new PrintWriter(System.out);
      new prefix_font(new FastScanner(System.in), out);
      out.close();
   }

   void add(Node cur, int i, String s, int id)
   {
      while (i < s.length())
      {
         int c = s.charAt(i)-'a';
         if (cur.next[c] == null)
            cur.next[c] = new Node();

         cur = cur.next[c];
         i++; 
      }

      cur.id = id;
   }

   public prefix_font(FastScanner in, PrintWriter out)
   {
      int N = in.nextInt();
      int K = in.nextInt();
      String[] dict = new String[N];
      for (int i=0; i<N; i++)
         dict[i] = in.next();
      Arrays.sort(dict);
      Node root = new Node();
      for (int i=0; i<N; i++)
         add(root, 0, dict[i], i);
      
      String result = in.next();
      Node cur = root;
      int[] perm = new int[K];
      int ptr = 0;
      for (int i=0; i<result.length(); i++)
      {
         int c = result.charAt(i)-'a';
         cur = cur.next[c];

         if (cur.id >= 0)
         {
            perm[ptr++] = cur.id; 
            cur = root;
         }
      }

      int MODO = 1_000_000_007;
      long[] fact = new long[K];
      fact[0] = 1;
      for (int i=1; i<K; i++)
      {
         fact[i] = fact[i-1] * (N-K+i);
         fact[i] %= MODO;
      }

      FenwickTree tree = new FenwickTree(N);
      for (int i=0; i<N; i++)
         tree.update(i, 1);

      long res = 0;
      int pos = K-1;
      for (int v : perm)
      {
         tree.update(v, -1);
         int x = tree.sum(v);
         res += x * fact[pos];
         res %= MODO;
         pos--;
      }

      out.println((res+1)%MODO);
   }
}

class FenwickTree
{
   int size;
   int[] table;

   FenwickTree(int size)
   {
      this.size = size;
      table = new int[size];
   }

   void update(int i, int delta)
   {
      while (i < size)
      {
         table[i] += delta;
         i |= i+1;
      }
   }

   int sum(int i)
   {
      int sum = 0;
      while (i >= 0)
      {
         sum += table[i];
         i = (i&(i+1))-1;
      }
      return sum;
   }
}

class Node
{
   Node[] next;
   int id;

   Node()
   {
      next = new Node[26];
      id = -1;
   }
}

class FastScanner{
    private InputStream stream;
    private byte[] buf = new byte[1024];
    private int curChar;
    private int numChars;
    
    public FastScanner(InputStream stream)
    {
        this.stream = stream;
    }
    
    int read()
    {
        if (numChars == -1)
            throw new InputMismatchException();
        if (curChar >= numChars){
            curChar = 0;
            try{
                numChars = stream.read(buf);
            } catch (IOException e) {
                throw new InputMismatchException();
            }
            if (numChars <= 0)
                return -1;
        }
        return buf[curChar++];
    }
    
    boolean isSpaceChar(int c)
    {
        return c==' '||c=='\n'||c=='\r'||c=='\t'||c==-1;
    }
    
    boolean isEndline(int c)
    {
        return c=='\n'||c=='\r'||c==-1;
    }
    
    int nextInt()
    {
        return Integer.parseInt(next());
    }
    
    long nextLong()
    {
        return Long.parseLong(next());
    }
    
    double nextDouble()
    {
        return Double.parseDouble(next());
    }
    
    String next(){
        int c = read();
        while (isSpaceChar(c))
            c = read();
        StringBuilder res = new StringBuilder();
        do{
            res.appendCodePoint(c);
            c = read();
        }while(!isSpaceChar(c));
        return res.toString();
    }
    
    String nextLine(){
        int c = read();
        while (isEndline(c))
            c = read();
        StringBuilder res = new StringBuilder();
        do{
            res.appendCodePoint(c);
            c = read();
        }while(!isEndline(c));
        return res.toString();
    }
}
