import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.util.InputMismatchException;
import java.io.IOException;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class prefixfree_lewin {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        OutputWriter out = new OutputWriter(outputStream);
        PrefixFreeCode solver = new PrefixFreeCode();
        solver.solve(1, in, out);
        out.close();
    }

    static class PrefixFreeCode {
        int mod = 1000000007;
        PrefixFreeCode.TrieNode root;

        void insert(String s) {
            PrefixFreeCode.TrieNode cur = root;
            for (char c : s.toCharArray()) {
                cur.count++;
                int pos = c - 'a';
                if (cur.next[pos] == null) cur.next[pos] = new PrefixFreeCode.TrieNode();
                cur = cur.next[pos];
            }
            cur.count++;
        }

        public void solve(int testNumber, InputReader in, OutputWriter out) {
            int n = in.nextInt(), k = in.nextInt();
            long[] mts = new long[k];
            mts[0] = 1;
            for (int i = 1; i < k; i++) {
                mts[i] = mts[i - 1] * (n - k + i) % mod;
            }

            root = new PrefixFreeCode.TrieNode();

            for (int i = 0; i < n; i++) insert(in.next());
            char[] s = in.next().toCharArray();
            PrefixFreeCode.TrieNode cur = root;
            int ans = 0;
            int rem = k - 1;
            for (char c : s) {
                int pos = c - 'a';
                int tot = 0;
                cur.count--;
                if (cur.next[pos] == null) {
                    rem--;
                    cur = root;
                }
                for (int i = 0; i < pos; i++) {
                    tot += cur.next[i] == null ? 0 : cur.next[i].count;
                }
                ans = (int) ((ans + mts[rem] * tot) % mod);
                cur = cur.next[pos];
            }
            out.println((1+ans)%mod);
        }

        static class TrieNode {
            public PrefixFreeCode.TrieNode[] next;
            public int count;

            public TrieNode() {
                next = new PrefixFreeCode.TrieNode[26];
            }

        }

    }

    static class InputReader {
        private InputStream stream;
        private byte[] buf = new byte[1 << 16];
        private int curChar;
        private int numChars;

        public InputReader(InputStream stream) {
            this.stream = stream;
        }

        public int read() {
            if (this.numChars == -1) {
                throw new InputMismatchException();
            } else {
                if (this.curChar >= this.numChars) {
                    this.curChar = 0;

                    try {
                        this.numChars = this.stream.read(this.buf);
                    } catch (IOException var2) {
                        throw new InputMismatchException();
                    }

                    if (this.numChars <= 0) {
                        return -1;
                    }
                }

                return this.buf[this.curChar++];
            }
        }

        public int nextInt() {
            int c;
            for (c = this.read(); isSpaceChar(c); c = this.read()) {
                ;
            }

            byte sgn = 1;
            if (c == 45) {
                sgn = -1;
                c = this.read();
            }

            int res = 0;

            while (c >= 48 && c <= 57) {
                res *= 10;
                res += c - 48;
                c = this.read();
                if (isSpaceChar(c)) {
                    return res * sgn;
                }
            }

            throw new InputMismatchException();
        }

        public String next() {
            int c;
            while (isSpaceChar(c = this.read())) {
                ;
            }

            StringBuilder result = new StringBuilder();
            result.appendCodePoint(c);

            while (!isSpaceChar(c = this.read())) {
                result.appendCodePoint(c);
            }

            return result.toString();
        }

        public static boolean isSpaceChar(int c) {
            return c == 32 || c == 10 || c == 13 || c == 9 || c == -1;
        }

    }

    static class OutputWriter {
        private final PrintWriter writer;

        public OutputWriter(OutputStream outputStream) {
            writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
        }

        public OutputWriter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public void close() {
            writer.close();
        }

        public void println(int i) {
            writer.println(i);
        }

    }
}

